function [P,N,Kfb,Kff] = kica(C,D,Wr,By)
%   KICA Generate linear incremental control allocation (ICA) in state-
%   feedback form 
%
%       Author: T.S.C. Pollack
%       Copyright (2024) T.S.C. Pollack

    % Get dimensions
    nu = size(D,2);
    
    % Augmented C-matrix
    V = [C D];

    % Get pseudo-inverse and null-space matrices
    Ri = (D'*D + Wr)\eye(nu);
    P  = Ri*By'*((By*Ri*By')\1);
    N  = eye(nu) - P*By;
    
    % Control gains
    Kfb = N*Ri*D'*V;
    Kff = zeros(size(P));
    

end