function [P,N,Ks,Kfb,Kff] = kica_tss(C,D,Wr,By)
%   KICA_TSS Generate linear incremental control allocation (ICA) in state-
%   feedback form (time-scale separation [TSS] leveraged)
%
%       Author: T.S.C. Pollack
%       Copyright (2024) T.S.C. Pollack

    % Get dimensions
    nu = size(D,2);
    
    % Get pseudo-inverse and null-space matrices
    Ri = (D'*D + Wr)\eye(nu);
    P  = Ri*By'*((By*Ri*By')\1);
    N  = eye(nu) - P*By;
    
    % Control gains
    Ks  = N*Ri*D';
    Kfb = zeros(size(C,2),size(D,2)*2);
    Kff = zeros(size(P));
    
end