function phase_lst_wrapped = phase_wrapper(phase_lst)
%   PHASE_WRAPPER Auxiliary function to wrap phase between [-180,180] deg
%   in Bode diagrams
%
%       Author: T.S.C. Pollack
%       Copyright (2024) T.S.C. Pollack

    idx_l = find(phase_lst < -180); idx_u = find(phase_lst > 180);
    
    while ~isempty(idx_l) || ~isempty(idx_u) 

        phase_lst(idx_l) = phase_lst(idx_l) + 360;
        phase_lst(idx_u) = phase_lst(idx_u) - 360;

        idx_l = find(phase_lst < -180); idx_u = find(phase_lst > 180);
        
    end
    
    phase_lst_wrapped = phase_lst;

end

